import { Injectable } from '@nestjs/common';
import { BaseDeleteManager } from 'src/core/modules/domain/usecase/managers/base-delete.manager';
import { {{pascalCase name}}Entity } from '../../entities/{{dashCase name}}.entity';
import { EventTopics, validateRelations } from 'src/core/strings/constants/interface.constants';
import { {{pascalCase name}}Model } from '../../../data/models/{{dashCase name}}.model';
import { {{pascalCase name}}DeletedEvent } from '../../entities/event/{{dashCase name}}-deleted.event';

@Injectable()
export class Delete{{pascalCase name}}Manager extends BaseDeleteManager<{{pascalCase name}}Entity> {
  getResult(): string {
    return `Success`;
  }

  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return {{pascalCase name}}Model;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: {{pascalCase name}}DeletedEvent,
        data: this.data,
      },
    ];
  }
}
